function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import Checked, { TYPE as CheckType } from "../../../Checked";
import Ellipsis from "../../../components/Ellipsis";
import classnames from 'classnames';
import { loadingIcon } from "../../../utils/icon";
import { getPrimary, getKey, getRowKeys, getErrorDisabled } from "../../../utils/tools";
import { AssistIcon } from "./assistIcon";
import { Icon } from 'rlj-design';
import { AttachmentUpload } from 'rlj-pro';
import { useSetAtom } from 'jotai';
import { hoverCellAtom } from "../../../State";
import RowPrefix from "./rowPrefix";
import "./index.less";
import Undertake from "../../../undertake";
import { areEqual } from "../../../validate";
import { foldKeySuffix, needShowCaretValueType } from "../../../utils/config";
var preSpClickFlag = false; // rowIndex columnIndex 等这些index，都是根据块noFixed fixLeft fixRight来作为索引开始的值

// 所有单元格cell都使用这个组件，但是这个Item只是起到分流的作用
var Item = function Item(props) {
  return /*#__PURE__*/React.createElement(Cell, props);
}; // 正儿八经的单元格


var CellCtx = /*#__PURE__*/React.memo(function (props) {
  var _getKey, _expandConfig$expandK;

  // console.log('Item-re-render');
  var rowIndex = props.rowIndex,
      currentData = props.currentData,
      currentColumn = props.currentColumn,
      excelCtx = props.excelCtx,
      style = props.style;
  var _ref = excelCtx,
      rowSelection = _ref.rowSelection,
      selectRow = _ref.selectRow,
      editableConfig = _ref.editableConfig,
      defaultShowCtx = _ref.defaultShowCtx,
      crosswalk = _ref.crosswalk,
      _ref$rowKey = _ref.rowKey,
      rowKey = _ref$rowKey === void 0 ? 'id' : _ref$rowKey,
      dataSource = _ref.dataSource,
      changeTable = _ref.changeTable,
      colData = _ref.colData,
      expandConfig = _ref.expandConfig,
      loadingExpandId = _ref.loadingExpandId;
  var isOdd = rowIndex % 2 !== 0; //是否奇数行

  var _ref2 = rowSelection || {},
      _ref2$selectedRowKeys = _ref2.selectedRowKeys,
      selectedRowKeys = _ref2$selectedRowKeys === void 0 ? [] : _ref2$selectedRowKeys;

  var _ref3 = editableConfig || {},
      editable = _ref3.editable,
      selectRowShowDel = _ref3.selectRowShowDel,
      _ref3$infos = _ref3.infos,
      infos = _ref3$infos === void 0 ? [] : _ref3$infos,
      _ref3$disabled = _ref3.disabled,
      disabledProps = _ref3$disabled === void 0 ? [] : _ref3$disabled;

  var handleHoverCell = useSetAtom(hoverCellAtom);
  var width = currentColumn.width,
      valueType = currentColumn.valueType,
      info = currentColumn.info,
      lastCol = currentColumn.lastCol,
      disabled = currentColumn.disabled,
      render = currentColumn.render;
  var dataIndex = getKey(currentColumn);
  var dataRowId = getRowKeys(rowKey, currentData); // 编辑态+不等于【显示斑马线】  或者  显示态+【显示斑马线】

  if (editable && crosswalk !== true || !editable && crosswalk === false) {
    isOdd = false;
  }

  var infoStatus = getErrorDisabled(infos, dataIndex, dataRowId);
  var isDisabled = disabled || !!getErrorDisabled(disabledProps, dataIndex, dataRowId);

  var preSpClick = function preSpClick() {
    if (preSpClickFlag) return;
    preSpClickFlag = true;
    changeTable({
      data: dataRowId,
      currentColumn: currentColumn,
      currentData: currentData
    }, 'delOneRow');
    setTimeout(function () {
      preSpClickFlag = false;
    }, 100);
  };

  var renderText = function renderText(curData) {
    return function () {
      // address file
      try {
        if (['selection', 'checkbox', 'emp', 'org'].includes(currentColumn.valueType || '')) {
          return curData === null || curData === void 0 ? void 0 : curData.map(function (v) {
            return v.label;
          }).join('、');
        }

        if (['address'].includes(currentColumn.valueType || '')) {
          return curData === null || curData === void 0 ? void 0 : curData.map(function (v) {
            return v.label;
          }).join('/');
        }

        if (['file'].includes(currentColumn.valueType || '')) {
          return /*#__PURE__*/React.createElement("div", {
            className: "uploadCell"
          }, editableConfig !== null && editableConfig !== void 0 && editableConfig.editable && !(curData !== null && curData !== void 0 && curData.length) ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(AttachmentUpload, _extends({
            action: "/api/files/upload",
            owner: currentData[dataRowId]
          }, editableConfig === null || editableConfig === void 0 ? void 0 : editableConfig.attachmentUploadProps, currentColumn === null || currentColumn === void 0 ? void 0 : currentColumn.attachmentUploadProps, {
            value: [],
            onChange: function onChange(data) {
              // @ts-ignore;
              if (!(data !== null && data !== void 0 && data.length)) return;
              changeTable({
                data: data,
                currentColumn: currentColumn,
                currentData: currentData
              }, 'changeOneCellWidthDown');
            }
          }))) : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(AttachmentUpload, _extends({
            owner: currentData[dataRowId],
            fileUrlHandle: function fileUrlHandle() {
              return 'https://static.dingtalk.com/media/lALPDf0i68_FJQ7NAyDNAyA_800_800.png_620x10000q90.jpg';
            }
          }, editableConfig === null || editableConfig === void 0 ? void 0 : editableConfig.attachmentUploadProps, currentColumn === null || currentColumn === void 0 ? void 0 : currentColumn.attachmentUploadProps, {
            disabled: true,
            value: curData
          })), /*#__PURE__*/React.createElement(Icon, {
            type: "delete",
            className: "uploadCellDelIcon",
            size: 14,
            onClick: function onClick() {
              changeTable({
                data: [],
                currentColumn: currentColumn,
                currentData: currentData
              }, 'changeOneCellWidthDown');
            }
          })));
        }

        return curData;
      } catch (error) {
        return curData;
      }
    };
  };

  var getLabel = function getLabel(ctxWidth) {
    var dataItem = currentData[dataIndex]; // 获取 dataIndex 指定的数据

    var renderItem = render || renderText(dataItem);
    var result = renderItem(dataItem, currentData, rowIndex, ctxWidth);
    var defaultShowText = defaultShowCtx === undefined ? '-' : defaultShowCtx;
    return [result === undefined ? defaultShowText : result, dataItem];
  }; // 第一个列内的第一个单元格，并且这个单元格标明了要显示图标 => 缩进特殊处理


  var isNeedPd = currentData.expandShowIcon !== false && currentColumn.expandCol; // 需要根据第一行数据是否显示图标来计算出具体的缩进距离

  var extraW = 0;

  if (isNeedPd) {
    extraW = (currentData.hierarchy - (dataSource[0].expandShowIcon !== false ? 0 : 1)) * 20;
  } // 先减掉左右固定的10 + 10的padding


  var ctxWidth = width - 20;

  if (info) {
    ctxWidth -= 20;
  }

  if (isNeedPd) {
    ctxWidth -= extraW;
  }

  if (currentColumn.valueType && needShowCaretValueType.includes(currentColumn.valueType)) {
    ctxWidth -= 26;
  }

  if (ctxWidth <= 22) {
    ctxWidth = 22;
    extraW = width - ctxWidth;
  }

  var _getLabel = getLabel(ctxWidth),
      _getLabel2 = _slicedToArray(_getLabel, 2),
      label = _getLabel2[0],
      labelText = _getLabel2[1];

  var isSpFoldCol = (_getKey = getKey(currentColumn)) === null || _getKey === void 0 ? void 0 : _getKey.includes(foldKeySuffix);
  var isFoldCol = currentColumn.foldInfo;
  /**
   * 层级, 从上大小依次变高, 对应css中, 从上到下写下来
   * salaryExcelDataItem    白色
   * dataItemGrey           灰色
   * rowPrefixSp            右边序号颜色
   * rowPrefixSpHighlight   右边序号高亮颜色
   * dataItemFold           折叠块底色
   * dataRowSelected        选中行 金色(深)
   * dataItemDisabled       禁用(灰色)
   * dataItemSelected       选中的单元格底色  白色
   * 单元格状态(无底色), 角标   没整, 看起来效果是对的, 先放放
   */

  return /*#__PURE__*/React.createElement(AssistIcon, {
    key: dataIndex,
    rowIndex: rowIndex,
    currentData: currentData,
    currentColumn: _objectSpread(_objectSpread({}, currentColumn), {}, {
      disabled: isDisabled
    }),
    width: width,
    style: style,
    fatherTmp: /*#__PURE__*/React.createElement("div", {
      className: getPrimary(classnames('salaryExcelDataItem', {
        delPadding: isSpFoldCol,
        intValueStyle: valueType === 'int' || valueType === 'number',
        lastColHiddenBorder: lastCol,
        dataItemGrey: isOdd,
        // 灰色
        rowPrefixSpCell: dataIndex === 'rowPrefixSp',
        // 序号列颜色
        rowPrefixSpHighlight: dataIndex === 'rowPrefixSp' && (selectRow === null || selectRow === void 0 ? void 0 : selectRow.rowIndex) === rowIndex,
        // 序列号高亮
        dataItemFold: isFoldCol,
        // 折叠块底色
        dataRowSelected: (selectRow === null || selectRow === void 0 ? void 0 : selectRow.rowIndex) === rowIndex,
        // 选中行
        dataItemSelected: (selectRow === null || selectRow === void 0 ? void 0 : selectRow.rowIndex) === rowIndex && selectRow.currentColumn.dataIndex === dataIndex,
        // 选中行
        dataItemDisabled: isDisabled,
        dataItemChecked: selectedRowKeys.includes(getRowKeys(rowKey, currentData))
      })),
      style: {
        width: width,
        height: colData.defaultItemHeight
      },
      onMouseEnter: function onMouseEnter() {
        return handleHoverCell(rowIndex);
      },
      onMouseLeave: function onMouseLeave() {
        return handleHoverCell(-1);
      }
    }),
    childrenTmp: /*#__PURE__*/React.createElement(React.Fragment, null, dataIndex === 'rowSelection' ? /*#__PURE__*/React.createElement(Checked, {
      type: CheckType.ctx,
      data: currentData,
      rowKey: rowKey,
      rowSelection: rowSelection
    }) : dataIndex === 'rowPrefixSp' ? /*#__PURE__*/React.createElement(RowPrefix, {
      selectRowShowDel: selectRowShowDel,
      selectRow: selectRow,
      rowIndex: rowIndex,
      onClick: preSpClick
    }) : /*#__PURE__*/React.createElement(React.Fragment, null, isNeedPd && /*#__PURE__*/React.createElement("div", {
      className: "salaryExcelArrow",
      style: {
        width: extraW
      }
    }, /*#__PURE__*/React.createElement("span", {
      onClick: function onClick() {
        return changeTable({
          data: undefined,
          currentColumn: currentColumn,
          currentData: currentData
        }, 'toggleRowExpand');
      }
    }, currentData.expandShowIcon !== false && currentData.expand && (loadingExpandId === currentData[(_expandConfig$expandK = expandConfig === null || expandConfig === void 0 ? void 0 : expandConfig.expandKey) !== null && _expandConfig$expandK !== void 0 ? _expandConfig$expandK : 'expandId'] ? loadingIcon : currentData.expandStatus ? /*#__PURE__*/React.createElement(Icon, {
      type: 'dropDownArrowDown',
      size: 12
    }) : /*#__PURE__*/React.createElement(Icon, {
      type: 'dropDownArrowRight',
      size: 12
    })))), isSpFoldCol ? '...' : /*#__PURE__*/React.createElement(Ellipsis, {
      text: label,
      width: ctxWidth,
      hover: infoStatus ? !infoStatus.msg : true,
      isMaxWidth: false
    }), info && /*#__PURE__*/React.createElement("div", {
      className: "salaryExcelDataInfo"
    }, info(labelText, currentData, rowIndex, ctxWidth))))
  });
}, areEqual);
var Cell = Undertake(CellCtx);
export default Item;